/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM flockIDiggService.idl
 */

#ifndef __gen_flockIDiggService_h__
#define __gen_flockIDiggService_h__


#ifndef __gen_flockIListener_h__
#include "flockIListener.h"
#endif

#ifndef __gen_flockISocialWebService_h__
#include "flockISocialWebService.h"
#endif

#ifndef __gen_flockIWebService_h__
#include "flockIWebService.h"
#endif

#ifndef __gen_flockIWebServiceAPI_h__
#include "flockIWebServiceAPI.h"
#endif

#ifndef __gen_nsIWritablePropertyBag2_h__
#include "nsIWritablePropertyBag2.h"
#endif

#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsITransferable_h__
#include "nsITransferable.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    flockIDiggAPI */
#define FLOCKIDIGGAPI_IID_STR "38f91ce3-8956-48bb-b8f7-001723e97c01"

#define FLOCKIDIGGAPI_IID \
  {0x38f91ce3, 0x8956, 0x48bb, \
    { 0xb8, 0xf7, 0x00, 0x17, 0x23, 0xe9, 0x7c, 0x01 }}

/**
 * Digg API
 */
class NS_NO_VTABLE NS_SCRIPTABLE flockIDiggAPI : public flockIWebServiceAPI {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FLOCKIDIGGAPI_IID)

  /**
   * Retrieves digg information for a particular URL.
   *
   * @param aURL (in) URL to get digg info for.
   * @param aFlockListener (in) listener to notify when activity is complete
   * @param aShouldGetTopStories (in) require top stories to refresh
   *
   * @see flockIDiggService#loadDiggInfo
   */
  /* void getDiggInformation (in AString aURL, in flockIListener aFlockListener, in PRBool aShouldGetTopStories); */
  NS_SCRIPTABLE NS_IMETHOD GetDiggInformation(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories) = 0;

  /**
   * Retrieves digg information for a particular Digg URL.
   *
   * @param aCleanTitle (in) Title from Digg URL, http://digg.com/{CLEAN_TITLE}
   * @param aFlockListener (in) listener to notify when activity is complete
   *
   * @see flockIDiggService#getDiggInfoByCleanTitle
   */
  /* void getDiggInfoByCleanTitle (in AString aCleanTitle, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener) = 0;

  /**
   * Retrieves the friends list for a particular user.
   *
   * @param aUsername (in) name of user to retrieve information for
   * @param aFlockListener (in) listener to notify when activity is complete
   */
  /* void getFriends (in AString aUsername, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD GetFriends(const nsAString & aUsername, flockIListener *aFlockListener) = 0;

  /**
   * Retrieves whether or not two users are friends
   *
   * @param aUsername (in) username of the first user to compare
   * @param aFriendUsername (in) username of the second user to compare
   * @param aFlockListener (in) listener to notify when activity is complete
   */
  /* void isFriend (in AString aUsername, in AString aFriendUsername, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener) = 0;

  /**
   * Retrieves user information from the Digg Service.
   *
   * @param aUsername (in) name of user to retrieve information for
   * @param aFlockListener (in) listener to notify when activity is complete
   */
  /* void getUser (in AString aUsername, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD GetUser(const nsAString & aUsername, flockIListener *aFlockListener) = 0;

  /**
   * Retrieves the top stories .
   *
   * @param aResults (in) A property bag to put any results in.
   * @param aFlockListener (in) listener to notify when activity is complete
   */
  /* void getTopStories (in nsIWritablePropertyBag2 aResults, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD GetTopStories(nsIWritablePropertyBag2 *aResults, flockIListener *aFlockListener) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(flockIDiggAPI, FLOCKIDIGGAPI_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIDIGGAPI \
  NS_SCRIPTABLE NS_IMETHOD GetDiggInformation(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories); \
  NS_SCRIPTABLE NS_IMETHOD GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener); \
  NS_SCRIPTABLE NS_IMETHOD GetFriends(const nsAString & aUsername, flockIListener *aFlockListener); \
  NS_SCRIPTABLE NS_IMETHOD IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener); \
  NS_SCRIPTABLE NS_IMETHOD GetUser(const nsAString & aUsername, flockIListener *aFlockListener); \
  NS_SCRIPTABLE NS_IMETHOD GetTopStories(nsIWritablePropertyBag2 *aResults, flockIListener *aFlockListener); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIDIGGAPI(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetDiggInformation(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories) { return _to GetDiggInformation(aURL, aFlockListener, aShouldGetTopStories); } \
  NS_SCRIPTABLE NS_IMETHOD GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener) { return _to GetDiggInfoByCleanTitle(aCleanTitle, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetFriends(const nsAString & aUsername, flockIListener *aFlockListener) { return _to GetFriends(aUsername, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener) { return _to IsFriend(aUsername, aFriendUsername, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetUser(const nsAString & aUsername, flockIListener *aFlockListener) { return _to GetUser(aUsername, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetTopStories(nsIWritablePropertyBag2 *aResults, flockIListener *aFlockListener) { return _to GetTopStories(aResults, aFlockListener); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIDIGGAPI(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetDiggInformation(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDiggInformation(aURL, aFlockListener, aShouldGetTopStories); } \
  NS_SCRIPTABLE NS_IMETHOD GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDiggInfoByCleanTitle(aCleanTitle, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetFriends(const nsAString & aUsername, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFriends(aUsername, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsFriend(aUsername, aFriendUsername, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetUser(const nsAString & aUsername, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUser(aUsername, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetTopStories(nsIWritablePropertyBag2 *aResults, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTopStories(aResults, aFlockListener); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIDiggAPI
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIDIGGAPI

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIDiggAPI)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void getDiggInformation (in AString aURL, in flockIListener aFlockListener, in PRBool aShouldGetTopStories); */
NS_IMETHODIMP _MYCLASS_::GetDiggInformation(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getDiggInfoByCleanTitle (in AString aCleanTitle, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getFriends (in AString aUsername, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::GetFriends(const nsAString & aUsername, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void isFriend (in AString aUsername, in AString aFriendUsername, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getUser (in AString aUsername, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::GetUser(const nsAString & aUsername, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getTopStories (in nsIWritablePropertyBag2 aResults, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::GetTopStories(nsIWritablePropertyBag2 *aResults, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    flockIDiggService */
#define FLOCKIDIGGSERVICE_IID_STR "2cf3495d-abcd-4e27-9a9f-74e6baada822"

#define FLOCKIDIGGSERVICE_IID \
  {0x2cf3495d, 0xabcd, 0x4e27, \
    { 0x9a, 0x9f, 0x74, 0xe6, 0xba, 0xad, 0xa8, 0x22 }}

/**
 * Digg Service
 */
class NS_NO_VTABLE NS_SCRIPTABLE flockIDiggService : public flockIWebService {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FLOCKIDIGGSERVICE_IID)

  /**
   * Loads page rank information for a given URL.
   *
   * @param aURL (in) url to retrieve page rank information for
   * @param aFlockListener (in) listener to retrieve information
   * @param aShouldGetTopStories (in) require top stories to refresh
   *
   * @see flockIDiggAPI#getDiggInformation
   */
  /* void loadDiggInfo (in AString aURL, in flockIListener aFlockListener, in PRBool aShouldGetTopStories); */
  NS_SCRIPTABLE NS_IMETHOD LoadDiggInfo(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories) = 0;

  /**
   * Retrieves the top stories.
   *
   * @param aListener (in) listener to notify when activity is complete
   */
  /* void getTopStories (in flockIListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD GetTopStories(flockIListener *aListener) = 0;

  /**
   * Loads page rank information for a given Digg URL.
   *
   * @param aCleanTitle (in) Title from Digg URL, http://digg.com/{CLEAN_TITLE}
   * @param aFlockListener (in) listener to notify when activity is complete
   *
   * @see flockIDiggAPI#getDiggInfoByCleanTitle
   */
  /* void getDiggInfoByCleanTitle (in AString aCleanTitle, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener) = 0;

  /**
   * Retrieves friend activity information from the Digg Service batch format.
   *
   * @param aAccount (in) current logged in digg account
   * @param aFriendsIds (in) list of friends Ids
   * @param aFlockListener (in) listener to notify when activity is complete
   */
  /* void getFriendsActivity (in flockISocialAccount aAccount, in nsIPropertyBag aFriendsIds, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD GetFriendsActivity(flockISocialAccount *aAccount, nsIPropertyBag *aFriendsIds, flockIListener *aFlockListener) = 0;

  /**
   * Determines if friend determined by aUsername is friend or not 
   *
   * @param aUsername (in) username of the first user to compare
   * @param aFriendUsername (in) username of the second user to compare
   * @param aFlockListener (in) listener to notify when activity is complete
   */
  /* void isFriend (in AString aUsername, in AString aFriendUsername, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(flockIDiggService, FLOCKIDIGGSERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIDIGGSERVICE \
  NS_SCRIPTABLE NS_IMETHOD LoadDiggInfo(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories); \
  NS_SCRIPTABLE NS_IMETHOD GetTopStories(flockIListener *aListener); \
  NS_SCRIPTABLE NS_IMETHOD GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener); \
  NS_SCRIPTABLE NS_IMETHOD GetFriendsActivity(flockISocialAccount *aAccount, nsIPropertyBag *aFriendsIds, flockIListener *aFlockListener); \
  NS_SCRIPTABLE NS_IMETHOD IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIDIGGSERVICE(_to) \
  NS_SCRIPTABLE NS_IMETHOD LoadDiggInfo(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories) { return _to LoadDiggInfo(aURL, aFlockListener, aShouldGetTopStories); } \
  NS_SCRIPTABLE NS_IMETHOD GetTopStories(flockIListener *aListener) { return _to GetTopStories(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener) { return _to GetDiggInfoByCleanTitle(aCleanTitle, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetFriendsActivity(flockISocialAccount *aAccount, nsIPropertyBag *aFriendsIds, flockIListener *aFlockListener) { return _to GetFriendsActivity(aAccount, aFriendsIds, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener) { return _to IsFriend(aUsername, aFriendUsername, aFlockListener); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIDIGGSERVICE(_to) \
  NS_SCRIPTABLE NS_IMETHOD LoadDiggInfo(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories) { return !_to ? NS_ERROR_NULL_POINTER : _to->LoadDiggInfo(aURL, aFlockListener, aShouldGetTopStories); } \
  NS_SCRIPTABLE NS_IMETHOD GetTopStories(flockIListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTopStories(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDiggInfoByCleanTitle(aCleanTitle, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetFriendsActivity(flockISocialAccount *aAccount, nsIPropertyBag *aFriendsIds, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFriendsActivity(aAccount, aFriendsIds, aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsFriend(aUsername, aFriendUsername, aFlockListener); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIDiggService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIDIGGSERVICE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIDiggService)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void loadDiggInfo (in AString aURL, in flockIListener aFlockListener, in PRBool aShouldGetTopStories); */
NS_IMETHODIMP _MYCLASS_::LoadDiggInfo(const nsAString & aURL, flockIListener *aFlockListener, PRBool aShouldGetTopStories)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getTopStories (in flockIListener aListener); */
NS_IMETHODIMP _MYCLASS_::GetTopStories(flockIListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getDiggInfoByCleanTitle (in AString aCleanTitle, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::GetDiggInfoByCleanTitle(const nsAString & aCleanTitle, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getFriendsActivity (in flockISocialAccount aAccount, in nsIPropertyBag aFriendsIds, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::GetFriendsActivity(flockISocialAccount *aAccount, nsIPropertyBag *aFriendsIds, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void isFriend (in AString aUsername, in AString aFriendUsername, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::IsFriend(const nsAString & aUsername, const nsAString & aFriendUsername, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_flockIDiggService_h__ */
