/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM flockIMyspaceAPI.idl
 */

#ifndef __gen_flockIMyspaceAPI_h__
#define __gen_flockIMyspaceAPI_h__


#ifndef __gen_flockIListener_h__
#include "flockIListener.h"
#endif

#ifndef __gen_flockIPhotoUpload_h__
#include "flockIPhotoUpload.h"
#endif

#ifndef __gen_flockIWebServiceAPI_h__
#include "flockIWebServiceAPI.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    flockIMyspaceAPI */
#define FLOCKIMYSPACEAPI_IID_STR "cf0bf1de-914f-44ce-8967-39a6719a392e"

#define FLOCKIMYSPACEAPI_IID \
  {0xcf0bf1de, 0x914f, 0x44ce, \
    { 0x89, 0x67, 0x39, 0xa6, 0x71, 0x9a, 0x39, 0x2e }}

class NS_NO_VTABLE NS_SCRIPTABLE flockIMyspaceAPI : public flockITokenAPI {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FLOCKIMYSPACEAPI_IID)

  /**
   * Get the profile of a specified user.
   * @param aUid  UserID of the user
   * @param aListener  a flockIListener to use to return the results via
   *                   flockIListener#onSuccess, or any errors via
   *                   flockIListener#onError.
   */
  /* void getMyProfile (in AString aUid, in flockIListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD GetMyProfile(const nsAString & aUid, flockIListener *aListener) = 0;

  /**
   * Get the indicators of a specified user.
   * @param aUid  UserID of the user
   * @param aListener  a flockIListener to use to return the indicators data
   *                   via flockIListener#onSuccess, or any errors via
   *                   flockIListener#onError.
   */
  /* void getMyIndicators (in AString aUid, in flockIListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD GetMyIndicators(const nsAString & aUid, flockIListener *aListener) = 0;

  /**
   * Get the friends of a specified user.
   * @param aUid  UserID of the user
   * @param aListener  a flockIListener to use to return the friends via
   *                   flockIListener#onSuccess, or any errors via
   *                   flockIListener#onError.
   */
  /* void getMyFriends (in AString aUid, in flockIListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD GetMyFriends(const nsAString & aUid, flockIListener *aListener) = 0;

  /**
   * Get the albums of a specified user.
   * @param aUid  UserID of the user
   * @param aListener  a flockIListener to use to return the albums via
   *                   flockIListener#onSuccess, or any errors via
   *                   flockIListener#onError.
   */
  /* void getUserAlbums (in AString aUid, in flockIListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD GetUserAlbums(const nsAString & aUid, flockIListener *aListener) = 0;

  /**
   * Sets the status of a specified user.
   * @param aUid  UserID of the user
   * @param aStatusMessage  Status of the user
   * @param aListener  a flockIListener to use to return the albums via
   *                   flockIListener#onSuccess, or any errors via
   *                   flockIListener#onError.
   */
  /* void setMyStatus (in AString aUid, in AString aStatusMessage, in flockIListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD SetMyStatus(const nsAString & aUid, const nsAString & aStatusMessage, flockIListener *aListener) = 0;

  /**
   * Upload photos to Myspace from the Flock Photo Uploader.
   *
   * @param aUploadListener (in) A flockIPhotoUploadAPIListener.
   * @param aFilename (in) An AString containing the full filename of the photo
   *                    to upload.
   * @param aParams (in) An nsIPropertyBag2 containing paramaters to pass to
   *                     flockIPhotoAPI#upload2.
   * @param aUpload (in) A flockIPhotoUpload.
   */
  /* void uploadPhotosViaUploader (in flockIPhotoUploadAPIListener aUploadListener, in AString aFilename, in nsIPropertyBag2 aParams, in flockIPhotoUpload aUpload); */
  NS_SCRIPTABLE NS_IMETHOD UploadPhotosViaUploader(flockIPhotoUploadAPIListener *aUploadListener, const nsAString & aFilename, nsIPropertyBag2 *aParams, flockIPhotoUpload *aUpload) = 0;

  /**
   * Create an album for this user
   *
   * @param aUid UserID of the user
   * @param aAlbumTitle (in) The title of the new album to create.
   * @param aFlockListener (in) A flockIListener which responds
   *                       flockIListener#onSuccess() with with the album that
   *                       was created.
   */
  /* void createAlbum (in AString aUid, in AString aAlbumTitle, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD CreateAlbum(const nsAString & aUid, const nsAString & aAlbumTitle, flockIListener *aFlockListener) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(flockIMyspaceAPI, FLOCKIMYSPACEAPI_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIMYSPACEAPI \
  NS_SCRIPTABLE NS_IMETHOD GetMyProfile(const nsAString & aUid, flockIListener *aListener); \
  NS_SCRIPTABLE NS_IMETHOD GetMyIndicators(const nsAString & aUid, flockIListener *aListener); \
  NS_SCRIPTABLE NS_IMETHOD GetMyFriends(const nsAString & aUid, flockIListener *aListener); \
  NS_SCRIPTABLE NS_IMETHOD GetUserAlbums(const nsAString & aUid, flockIListener *aListener); \
  NS_SCRIPTABLE NS_IMETHOD SetMyStatus(const nsAString & aUid, const nsAString & aStatusMessage, flockIListener *aListener); \
  NS_SCRIPTABLE NS_IMETHOD UploadPhotosViaUploader(flockIPhotoUploadAPIListener *aUploadListener, const nsAString & aFilename, nsIPropertyBag2 *aParams, flockIPhotoUpload *aUpload); \
  NS_SCRIPTABLE NS_IMETHOD CreateAlbum(const nsAString & aUid, const nsAString & aAlbumTitle, flockIListener *aFlockListener); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIMYSPACEAPI(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetMyProfile(const nsAString & aUid, flockIListener *aListener) { return _to GetMyProfile(aUid, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetMyIndicators(const nsAString & aUid, flockIListener *aListener) { return _to GetMyIndicators(aUid, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetMyFriends(const nsAString & aUid, flockIListener *aListener) { return _to GetMyFriends(aUid, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetUserAlbums(const nsAString & aUid, flockIListener *aListener) { return _to GetUserAlbums(aUid, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD SetMyStatus(const nsAString & aUid, const nsAString & aStatusMessage, flockIListener *aListener) { return _to SetMyStatus(aUid, aStatusMessage, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD UploadPhotosViaUploader(flockIPhotoUploadAPIListener *aUploadListener, const nsAString & aFilename, nsIPropertyBag2 *aParams, flockIPhotoUpload *aUpload) { return _to UploadPhotosViaUploader(aUploadListener, aFilename, aParams, aUpload); } \
  NS_SCRIPTABLE NS_IMETHOD CreateAlbum(const nsAString & aUid, const nsAString & aAlbumTitle, flockIListener *aFlockListener) { return _to CreateAlbum(aUid, aAlbumTitle, aFlockListener); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIMYSPACEAPI(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetMyProfile(const nsAString & aUid, flockIListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMyProfile(aUid, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetMyIndicators(const nsAString & aUid, flockIListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMyIndicators(aUid, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetMyFriends(const nsAString & aUid, flockIListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMyFriends(aUid, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetUserAlbums(const nsAString & aUid, flockIListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUserAlbums(aUid, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD SetMyStatus(const nsAString & aUid, const nsAString & aStatusMessage, flockIListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetMyStatus(aUid, aStatusMessage, aListener); } \
  NS_SCRIPTABLE NS_IMETHOD UploadPhotosViaUploader(flockIPhotoUploadAPIListener *aUploadListener, const nsAString & aFilename, nsIPropertyBag2 *aParams, flockIPhotoUpload *aUpload) { return !_to ? NS_ERROR_NULL_POINTER : _to->UploadPhotosViaUploader(aUploadListener, aFilename, aParams, aUpload); } \
  NS_SCRIPTABLE NS_IMETHOD CreateAlbum(const nsAString & aUid, const nsAString & aAlbumTitle, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateAlbum(aUid, aAlbumTitle, aFlockListener); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIMyspaceAPI
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIMYSPACEAPI

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIMyspaceAPI)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void getMyProfile (in AString aUid, in flockIListener aListener); */
NS_IMETHODIMP _MYCLASS_::GetMyProfile(const nsAString & aUid, flockIListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getMyIndicators (in AString aUid, in flockIListener aListener); */
NS_IMETHODIMP _MYCLASS_::GetMyIndicators(const nsAString & aUid, flockIListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getMyFriends (in AString aUid, in flockIListener aListener); */
NS_IMETHODIMP _MYCLASS_::GetMyFriends(const nsAString & aUid, flockIListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getUserAlbums (in AString aUid, in flockIListener aListener); */
NS_IMETHODIMP _MYCLASS_::GetUserAlbums(const nsAString & aUid, flockIListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setMyStatus (in AString aUid, in AString aStatusMessage, in flockIListener aListener); */
NS_IMETHODIMP _MYCLASS_::SetMyStatus(const nsAString & aUid, const nsAString & aStatusMessage, flockIListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void uploadPhotosViaUploader (in flockIPhotoUploadAPIListener aUploadListener, in AString aFilename, in nsIPropertyBag2 aParams, in flockIPhotoUpload aUpload); */
NS_IMETHODIMP _MYCLASS_::UploadPhotosViaUploader(flockIPhotoUploadAPIListener *aUploadListener, const nsAString & aFilename, nsIPropertyBag2 *aParams, flockIPhotoUpload *aUpload)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void createAlbum (in AString aUid, in AString aAlbumTitle, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::CreateAlbum(const nsAString & aUid, const nsAString & aAlbumTitle, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_flockIMyspaceAPI_h__ */
