/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM flockIReaderExtension.idl
 */

#ifndef __gen_flockIReaderExtension_h__
#define __gen_flockIReaderExtension_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */

class nsIDOMDocument; /* forward declaration */

class flockIListener; /* forward declaration */


/* starting interface:    flockIReaderExtension */
#define FLOCKIREADEREXTENSION_IID_STR "0fff463c-75a0-4deb-a5ca-fd144a3c51e3"

#define FLOCKIREADEREXTENSION_IID \
  {0x0fff463c, 0x75a0, 0x4deb, \
    { 0xa5, 0xca, 0xfd, 0x14, 0x4a, 0x3c, 0x51, 0xe3 }}

/**
 * Any service can add an icon to the bottom of each news feed article
 * by implementing this interface and registering itself in the category
 * manager under "flockReaderExtension" with its contract id as value
 */
class NS_NO_VTABLE NS_SCRIPTABLE flockIReaderExtension : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FLOCKIREADEREXTENSION_IID)

  /**
   * The chrome URL to the CSS file to be added to the stream reader,
   * to render what will be added in the footer of each article
   */
  /* readonly attribute AString styleSheetUrl; */
  NS_SCRIPTABLE NS_IMETHOD GetStyleSheetUrl(nsAString & aStyleSheetUrl) = 0;

  /**
   * Return the DOM node to be added to the footer of the article
   * @param aDocument: the document in which the element is to be inserted
   * @param aURI: the URI corresponding to the permalink to the articl
   * @param aFlockListener: the listener through which a nsIDOMElement will be
   * returned.
   *
   * @return the DOM element to be inserted
   */
  /* void createFooterElement (in nsIDOMDocument aDocument, in nsIURI aURI, in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD CreateFooterElement(nsIDOMDocument *aDocument, nsIURI *aURI, flockIListener *aFlockListener) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(flockIReaderExtension, FLOCKIREADEREXTENSION_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIREADEREXTENSION \
  NS_SCRIPTABLE NS_IMETHOD GetStyleSheetUrl(nsAString & aStyleSheetUrl); \
  NS_SCRIPTABLE NS_IMETHOD CreateFooterElement(nsIDOMDocument *aDocument, nsIURI *aURI, flockIListener *aFlockListener); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIREADEREXTENSION(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetStyleSheetUrl(nsAString & aStyleSheetUrl) { return _to GetStyleSheetUrl(aStyleSheetUrl); } \
  NS_SCRIPTABLE NS_IMETHOD CreateFooterElement(nsIDOMDocument *aDocument, nsIURI *aURI, flockIListener *aFlockListener) { return _to CreateFooterElement(aDocument, aURI, aFlockListener); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIREADEREXTENSION(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetStyleSheetUrl(nsAString & aStyleSheetUrl) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStyleSheetUrl(aStyleSheetUrl); } \
  NS_SCRIPTABLE NS_IMETHOD CreateFooterElement(nsIDOMDocument *aDocument, nsIURI *aURI, flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateFooterElement(aDocument, aURI, aFlockListener); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIReaderExtension
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIREADEREXTENSION

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIReaderExtension)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString styleSheetUrl; */
NS_IMETHODIMP _MYCLASS_::GetStyleSheetUrl(nsAString & aStyleSheetUrl)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void createFooterElement (in nsIDOMDocument aDocument, in nsIURI aURI, in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::CreateFooterElement(nsIDOMDocument *aDocument, nsIURI *aURI, flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_flockIReaderExtension_h__ */
